/* Copyright (c) 1996 by Lele Gaifax.  All Rights Reserved
 *
 * This file is part of Nothing (yet).
 *
 * $RCSfile: Forwarder.h,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/09/30 06:06:50 $
 *
 * Created Thu Sep  5 17:35:14 1996.
 */

#ifndef _Forwarder_H
#define _Forwarder_H

#include <objc/Object.h>
#include "OC_PythonObject.h"

/*#C This class does something really interesting... */
@interface Forwarder : Object
{
  id <PythonObject> delegate;
}

//#M Initialize the version number of this class.
+ (void) initialize;

- (BOOL) respondsTo:(SEL) aSelector;

- (void) setDelegate:(id <PythonObject>) aDelegate;

- performMethodOnDelegate;

- performUnknownMethodOnDelegate;

@end /* Forwarder class interface */


#endif /* _Forwarder_H */
