/* Copyright (c) 1996 by Lele Gaifax.  All Rights Reserved
 *
 * This file is part of the PyObjC package.
 *
 * $RCSfile: StructUser.h,v $
 * $Revision: 1.1.1.2 $
 * $Date: 1996/11/14 01:49:54 $
 *
 * Created Mon Sep  9 18:20:56 1996.
 */

#ifndef _StructUser_H
#define _StructUser_H

#include <objc/Object.h>
#include <pwd.h>

/*#C This class does something really interesting... */
@interface StructUser : Object
{
  struct passwd pwdEntry;
}

//#M Initialize the version number of this class.
+ (void) initialize;

+ me;

- initWithUserId:(int) uid;

- initWithPasswd:(struct passwd) aPwdEntry;

- (void) show;

- (struct passwd) pwdEntry;

- (double) multiplyUserIdBy:(float) f;

@end /* StructUser class interface */


#endif /* _StructUser_H */
