#/**
#*** Copyright (c) 1996 by Bill Bumgarner.  All Rights Reserved
#*** 
#*** This software may be used and distributed freely for any purpose
#*** provided that this notice is included unchanged on any and all copies.
#*** The author does not warrant or guarantee this software in any way.
#*** 
#*** 
#*** All queries, patches, and discussions of the PyObjC project should be
#*** directed to <objc-sig@python.org>.  The author can be reached via
#*** <bbum@friday.com>.
#*** 
#*** $RCSfile: ExpandURL.py,v $
#*** 
#*** $Revision: 1.3 $
#*** 
#*** $Date: 1996/10/24 23:18:21 $
#*** 
#**/

from PyServicesPackage import PyServicesHandler
import sys
import urllib

def servicesHandler(handler, pb, userData):
   try:
	  ## unpack pasteboard-- must send it -types first.
	  pb.types()
	  
	  stream = pb.dataForType_('NXAsciiPboardType')
	  url = stream.read()

	  ## open & read URL
	  u = urllib.urlopen(url)
	  body = u.read()
	  try:
		 ### try to quit
		 u.quit()
	  except:
		 ### failing that, close
		 u.close()
	  del(u)

	  ## write to pastpasteboardeboard
	  pb.setData_forType_(body, 'NXAsciiPboardType')
   except IOError, args:
	  m, e = sys.exc_value
	  t = '\nIOError: %s - %s'%(m, e)
	  raise PyServicesHandler.VisibleError, t
   


